<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>ConfigurationInterpolator (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ConfigurationInterpolator (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":9,"i5":10,"i6":9,"i7":10,"i8":10,"i9":10,"i10":10,"i11":9,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ConfigurationInterpolator.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/apache/commons/configuration2/interpol/ConstantLookup.html" title="class in org.apache.commons.configuration2.interpol"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" target="_top">Frames</a></li>
<li><a href="ConfigurationInterpolator.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.interpol</div>
<h2 title="Class ConfigurationInterpolator" class="title">Class ConfigurationInterpolator</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.interpol.ConfigurationInterpolator</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">ConfigurationInterpolator</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></pre>
<div class="block"><p>
 A class that handles interpolation (variable substitution) for configuration
 objects.
 </p>
 <p>
 Each instance of <code>AbstractConfiguration</code> is associated with an object
 of this class. All interpolation tasks are delegated to this object.
 </p>
 <p>
 <code>ConfigurationInterpolator</code> internally uses the <code>StrSubstitutor</code>
 class from <a href="http://commons.apache.org/lang">Commons Lang</a>. Thus it
 supports the same syntax of variable expressions.
 </p>
 <p>
 The basic idea of this class is that it can maintain a set of primitive
 <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol"><code>Lookup</code></a> objects, each of which is identified by a special prefix. The
 variables to be processed have the form <code>${prefix:name}</code>.
 <code>ConfigurationInterpolator</code> will extract the prefix and determine,
 which primitive lookup object is registered for it. Then the name of the
 variable is passed to this object to obtain the actual value. It is also
 possible to define an arbitrary number of default lookup objects, which are
 used for variables that do not have a prefix or that cannot be resolved by
 their associated lookup object. When adding default lookup objects their
 order matters; they are queried in this order, and the first non-<b>null</b>
 variable value is used.
 </p>
 <p>
 After an instance has been created it does not contain any <code>Lookup</code>
 objects. The current set of lookup objects can be modified using the
 <code>registerLookup()</code> and <code>deregisterLookup()</code> methods. Default
 lookup objects (that are invoked for variables without a prefix) can be added
 or removed with the <code>addDefaultLookup()</code> and
 <code>removeDefaultLookup()</code> methods respectively. (When a
 <code>ConfigurationInterpolator</code> instance is created by a configuration
 object, a default lookup object is added pointing to the configuration
 itself, so that variables are resolved using the configuration's properties.)
 </p>
 <p>
 The default usage scenario is that on a fully initialized instance the
 <code>interpolate()</code> method is called. It is passed an object value which
 may contain variables. All these variables are substituted if they can be
 resolved. The result is the passed in value with variables replaced.
 Alternatively, the <code>resolve()</code> method can be called to obtain the
 values of specific variables without performing interpolation.
 </p>
 <p>
 Implementation node: This class is thread-safe. Lookup objects can be added
 or removed at any time concurrent to interpolation operations.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.4</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: ConfigurationInterpolator.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a
         href="http://commons.apache.org/configuration/team-list.html">Commons
         Configuration team</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#ConfigurationInterpolator--">ConfigurationInterpolator</a></span>()</code>
<div class="block">Creates a new instance of <code>ConfigurationInterpolator</code>.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#addDefaultLookup-org.apache.commons.configuration2.interpol.Lookup-">addDefaultLookup</a></span>(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;defaultLookup)</code>
<div class="block">Adds a default <code>Lookup</code> object.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#addDefaultLookups-java.util.Collection-">addDefaultLookups</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;lookups)</code>
<div class="block">Adds all <code>Lookup</code> objects in the given collection as default
 lookups.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#deregisterLookup-java.lang.String-">deregisterLookup</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix)</code>
<div class="block">Deregisters the <code>Lookup</code> object for the specified prefix at this
 instance.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#fetchLookupForPrefix-java.lang.String-">fetchLookupForPrefix</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix)</code>
<div class="block">Obtains the lookup object for the specified prefix.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>static <a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#fromSpecification-org.apache.commons.configuration2.interpol.InterpolatorSpecification-">fromSpecification</a></span>(<a href="../../../../../org/apache/commons/configuration2/interpol/InterpolatorSpecification.html" title="class in org.apache.commons.configuration2.interpol">InterpolatorSpecification</a>&nbsp;spec)</code>
<div class="block">Creates a new <code>ConfigurationInterpolator</code> instance based on the
 passed in specification object.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#getDefaultLookups--">getDefaultLookups</a></span>()</code>
<div class="block">Returns a collection with the default <code>Lookup</code> objects
 added to this <code>ConfigurationInterpolator</code>.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>static <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#getDefaultPrefixLookups--">getDefaultPrefixLookups</a></span>()</code>
<div class="block">Returns a map containing the default prefix lookups.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#getLookups--">getLookups</a></span>()</code>
<div class="block">Returns a map with the currently registered <code>Lookup</code> objects and
 their prefixes.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#getParentInterpolator--">getParentInterpolator</a></span>()</code>
<div class="block">Returns the parent <code>ConfigurationInterpolator</code>.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#interpolate-java.lang.Object-">interpolate</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value)</code>
<div class="block">Performs interpolation of the passed in value.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#isEnableSubstitutionInVariables--">isEnableSubstitutionInVariables</a></span>()</code>
<div class="block">Sets a flag that variable names can contain other variables.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>static <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#nullSafeLookup-org.apache.commons.configuration2.interpol.Lookup-">nullSafeLookup</a></span>(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</code>
<div class="block">Utility method for obtaining a <code>Lookup</code> object in a safe way.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#prefixSet--">prefixSet</a></span>()</code>
<div class="block">Returns an unmodifiable set with the prefixes, for which <code>Lookup</code>
 objects are registered at this instance.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#registerLookup-java.lang.String-org.apache.commons.configuration2.interpol.Lookup-">registerLookup</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix,
              <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</code>
<div class="block">Registers the given <code>Lookup</code> object for the specified prefix at
 this instance.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#registerLookups-java.util.Map-">registerLookups</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,? extends <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;lookups)</code>
<div class="block">Registers all <code>Lookup</code> objects in the given map with their prefixes
 at this <code>ConfigurationInterpolator</code>.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#removeDefaultLookup-org.apache.commons.configuration2.interpol.Lookup-">removeDefaultLookup</a></span>(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</code>
<div class="block">Removes the specified <code>Lookup</code> object from the list of default
 <code>Lookup</code>s.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#resolve-java.lang.String-">resolve</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;var)</code>
<div class="block">Resolves the specified variable.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#setEnableSubstitutionInVariables-boolean-">setEnableSubstitutionInVariables</a></span>(boolean&nbsp;f)</code>
<div class="block">Sets the flag whether variable names can contain other variables.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html#setParentInterpolator-org.apache.commons.configuration2.interpol.ConfigurationInterpolator-">setParentInterpolator</a></span>(<a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a>&nbsp;parentInterpolator)</code>
<div class="block">Sets the parent <code>ConfigurationInterpolator</code>.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="ConfigurationInterpolator--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>ConfigurationInterpolator</h4>
<pre>public&nbsp;ConfigurationInterpolator()</pre>
<div class="block">Creates a new instance of <code>ConfigurationInterpolator</code>.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="fromSpecification-org.apache.commons.configuration2.interpol.InterpolatorSpecification-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fromSpecification</h4>
<pre>public static&nbsp;<a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a>&nbsp;fromSpecification(<a href="../../../../../org/apache/commons/configuration2/interpol/InterpolatorSpecification.html" title="class in org.apache.commons.configuration2.interpol">InterpolatorSpecification</a>&nbsp;spec)</pre>
<div class="block">Creates a new <code>ConfigurationInterpolator</code> instance based on the
 passed in specification object. If the <code>InterpolatorSpecification</code>
 already contains a <code>ConfigurationInterpolator</code> object, it is used
 directly. Otherwise, a new instance is created and initialized with the
 properties stored in the specification.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>spec</code> - the <code>InterpolatorSpecification</code> (must not be
        <b>null</b>)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>ConfigurationInterpolator</code> obtained or created based
         on the given specification</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the specification is <b>null</b></dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
</dl>
</li>
</ul>
<a name="getDefaultPrefixLookups--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDefaultPrefixLookups</h4>
<pre>public static&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;getDefaultPrefixLookups()</pre>
<div class="block">Returns a map containing the default prefix lookups. Every configuration
 object derived from <code>AbstractConfiguration</code> is by default
 initialized with a <code>ConfigurationInterpolator</code> containing these
 <code>Lookup</code> objects and their prefixes. The map cannot be modified</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a map with the default prefix <code>Lookup</code> objects and their
         prefixes</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
</dl>
</li>
</ul>
<a name="nullSafeLookup-org.apache.commons.configuration2.interpol.Lookup-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nullSafeLookup</h4>
<pre>public static&nbsp;<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;nullSafeLookup(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</pre>
<div class="block">Utility method for obtaining a <code>Lookup</code> object in a safe way. This
 method always returns a non-<b>null</b> <code>Lookup</code> object. If the
 passed in <code>Lookup</code> is not <b>null</b>, it is directly returned.
 Otherwise, result is a dummy <code>Lookup</code> which does not provide any
 values.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lookup</code> - the <code>Lookup</code> to check</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a non-<b>null</b> <code>Lookup</code> object</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
</dl>
</li>
</ul>
<a name="getLookups--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLookups</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;getLookups()</pre>
<div class="block">Returns a map with the currently registered <code>Lookup</code> objects and
 their prefixes. This is a snapshot copy of the internally used map. So
 modifications of this map do not effect this instance.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a copy of the map with the currently registered <code>Lookup</code>
         objects</dd>
</dl>
</li>
</ul>
<a name="registerLookup-java.lang.String-org.apache.commons.configuration2.interpol.Lookup-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>registerLookup</h4>
<pre>public&nbsp;void&nbsp;registerLookup(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix,
                           <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</pre>
<div class="block">Registers the given <code>Lookup</code> object for the specified prefix at
 this instance. From now on this lookup object will be used for variables
 that have the specified prefix.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>prefix</code> - the variable prefix (must not be <b>null</b>)</dd>
<dd><code>lookup</code> - the <code>Lookup</code> object to be used for this prefix (must
        not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if either the prefix or the
         <code>Lookup</code> object is <b>null</b></dd>
</dl>
</li>
</ul>
<a name="registerLookups-java.util.Map-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>registerLookups</h4>
<pre>public&nbsp;void&nbsp;registerLookups(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,? extends <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;lookups)</pre>
<div class="block">Registers all <code>Lookup</code> objects in the given map with their prefixes
 at this <code>ConfigurationInterpolator</code>. Using this method multiple
 <code>Lookup</code> objects can be registered at once. If the passed in map is
 <b>null</b>, this method does not have any effect.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lookups</code> - the map with lookups to register (may be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the map contains <b>entries</b></dd>
</dl>
</li>
</ul>
<a name="deregisterLookup-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>deregisterLookup</h4>
<pre>public&nbsp;boolean&nbsp;deregisterLookup(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix)</pre>
<div class="block">Deregisters the <code>Lookup</code> object for the specified prefix at this
 instance. It will be removed from this instance.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>prefix</code> - the variable prefix</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag whether for this prefix a lookup object had been
         registered</dd>
</dl>
</li>
</ul>
<a name="prefixSet--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prefixSet</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Set.html?is-external=true" title="class or interface in java.util">Set</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;prefixSet()</pre>
<div class="block">Returns an unmodifiable set with the prefixes, for which <code>Lookup</code>
 objects are registered at this instance. This means that variables with
 these prefixes can be processed.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a set with the registered variable prefixes</dd>
</dl>
</li>
</ul>
<a name="getDefaultLookups--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDefaultLookups</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;getDefaultLookups()</pre>
<div class="block">Returns a collection with the default <code>Lookup</code> objects
 added to this <code>ConfigurationInterpolator</code>. These objects are not
 associated with a variable prefix. The returned list is a snapshot copy
 of the internal collection of default lookups; so manipulating it does
 not affect this instance.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the default lookup objects</dd>
</dl>
</li>
</ul>
<a name="addDefaultLookup-org.apache.commons.configuration2.interpol.Lookup-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addDefaultLookup</h4>
<pre>public&nbsp;void&nbsp;addDefaultLookup(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;defaultLookup)</pre>
<div class="block">Adds a default <code>Lookup</code> object. Default <code>Lookup</code> objects are
 queried (in the order they were added) for all variables without a
 special prefix. If no default <code>Lookup</code> objects are present, such
 variables won't be processed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>defaultLookup</code> - the default <code>Lookup</code> object to be added (must
        not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the <code>Lookup</code> object is
         <b>null</b></dd>
</dl>
</li>
</ul>
<a name="addDefaultLookups-java.util.Collection-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addDefaultLookups</h4>
<pre>public&nbsp;void&nbsp;addDefaultLookups(<a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;? extends <a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&gt;&nbsp;lookups)</pre>
<div class="block">Adds all <code>Lookup</code> objects in the given collection as default
 lookups. The collection can be <b>null</b>, then this method has no
 effect. It must not contain <b>null</b> entries.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lookups</code> - the <code>Lookup</code> objects to be added as default lookups</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the collection contains a <b>null</b>
         entry</dd>
</dl>
</li>
</ul>
<a name="removeDefaultLookup-org.apache.commons.configuration2.interpol.Lookup-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeDefaultLookup</h4>
<pre>public&nbsp;boolean&nbsp;removeDefaultLookup(<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;lookup)</pre>
<div class="block">Removes the specified <code>Lookup</code> object from the list of default
 <code>Lookup</code>s.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lookup</code> - the <code>Lookup</code> object to be removed</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a flag whether this <code>Lookup</code> object actually existed and
         was removed</dd>
</dl>
</li>
</ul>
<a name="setParentInterpolator-org.apache.commons.configuration2.interpol.ConfigurationInterpolator-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setParentInterpolator</h4>
<pre>public&nbsp;void&nbsp;setParentInterpolator(<a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a>&nbsp;parentInterpolator)</pre>
<div class="block">Sets the parent <code>ConfigurationInterpolator</code>. This object is used if
 the <code>Lookup</code> objects registered at this object cannot resolve a
 variable.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parentInterpolator</code> - the parent <code>ConfigurationInterpolator</code>
        object (can be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="getParentInterpolator--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParentInterpolator</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" title="class in org.apache.commons.configuration2.interpol">ConfigurationInterpolator</a>&nbsp;getParentInterpolator()</pre>
<div class="block">Returns the parent <code>ConfigurationInterpolator</code>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the parent <code>ConfigurationInterpolator</code> (can be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="isEnableSubstitutionInVariables--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEnableSubstitutionInVariables</h4>
<pre>public&nbsp;boolean&nbsp;isEnableSubstitutionInVariables()</pre>
<div class="block">Sets a flag that variable names can contain other variables. If enabled,
 variable substitution is also done in variable names.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the substitution in variables flag</dd>
</dl>
</li>
</ul>
<a name="setEnableSubstitutionInVariables-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setEnableSubstitutionInVariables</h4>
<pre>public&nbsp;void&nbsp;setEnableSubstitutionInVariables(boolean&nbsp;f)</pre>
<div class="block">Sets the flag whether variable names can contain other variables. This
 flag corresponds to the <code>enableSubstitutionInVariables</code> property of
 the underlying <code>StrSubstitutor</code> object.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>f</code> - the new value of the flag</dd>
</dl>
</li>
</ul>
<a name="interpolate-java.lang.Object-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>interpolate</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;interpolate(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value)</pre>
<div class="block">Performs interpolation of the passed in value. If the value is of type
 String, this method checks whether it contains variables. If so, all
 variables are replaced by their current values (if possible). For non
 string arguments, the value is returned without changes.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>value</code> - the value to be interpolated</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the interpolated value</dd>
</dl>
</li>
</ul>
<a name="resolve-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>resolve</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;resolve(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;var)</pre>
<div class="block">Resolves the specified variable. This implementation tries to extract
 a variable prefix from the given variable name (the first colon (':') is
 used as prefix separator). It then passes the name of the variable with
 the prefix stripped to the lookup object registered for this prefix. If
 no prefix can be found or if the associated lookup object cannot resolve
 this variable, the default lookup objects are used. If this is not
 successful either and a parent <code>ConfigurationInterpolator</code> is
 available, this object is asked to resolve the variable.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>var</code> - the name of the variable whose value is to be looked up</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the value of this variable or <b>null</b> if it cannot be
 resolved</dd>
</dl>
</li>
</ul>
<a name="fetchLookupForPrefix-java.lang.String-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>fetchLookupForPrefix</h4>
<pre>protected&nbsp;<a href="../../../../../org/apache/commons/configuration2/interpol/Lookup.html" title="interface in org.apache.commons.configuration2.interpol">Lookup</a>&nbsp;fetchLookupForPrefix(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;prefix)</pre>
<div class="block">Obtains the lookup object for the specified prefix. This method is called
 by the <code>lookup()</code> method. This implementation will check
 whether a lookup object is registered for the given prefix. If not, a
 <b>null</b> lookup object will be returned (never <b>null</b>).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>prefix</code> - the prefix</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the lookup object to be used for this prefix</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/ConfigurationInterpolator.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../org/apache/commons/configuration2/interpol/ConstantLookup.html" title="class in org.apache.commons.configuration2.interpol"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/interpol/ConfigurationInterpolator.html" target="_top">Frames</a></li>
<li><a href="ConfigurationInterpolator.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
